﻿using System;
using System.Reflection;
using System.Windows;

using Prism.Ioc;
using Prism.Mvvm;
using Prism.Unity;

using TestProject.Views;

namespace TestProject
{
    /// <summary>
    /// 메인 애플리케이션
    /// </summary>
    public partial class MainApplication : PrismApplication
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 쉘 생성하기 - CreateShell()

        /// <summary>
        /// 쉘 생성하기
        /// </summary>
        /// <returns>쉘</returns>
        protected override Window CreateShell()
        {
            return Container.Resolve<MainWindow>();
        }

        #endregion
        #region 타입 등록하기 - RegisterTypes(containerRegistry)

        /// <summary>
        /// 타입 등록하기
        /// </summary>
        /// <param name="containerRegistry">컨테이너 레지스트리 인터페이스</param>
        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
        }

        #endregion
        #region 뷰 모델 로케이터 구성하기 - ConfigureViewModelLocator()

        /// <summary>
        /// 뷰 모델 로케이터 구성하기
        /// </summary>
        protected override void ConfigureViewModelLocator()
        {
            base.ConfigureViewModelLocator();

            ViewModelLocationProvider.SetDefaultViewTypeToViewModelTypeResolver
            (
                (viewType) =>
                {
                    string viewName = viewType.FullName;

                    string viewAssemblyName = viewType.GetTypeInfo().Assembly.FullName;

                    string viewModelName = $"{viewName}ViewModel, {viewAssemblyName}";

                    return Type.GetType(viewModelName);
                }
            );
        }

        #endregion
    }
}